'use strict';const PropTypes=require('prop-types'),React=require('react'),BasicTable=require('../../basic-table/basic-table'),CreateModelButton=require('../../create-model-button/create-model-button'),DateDisplay=require('../../date-display/date-display'),Popup=require('../../popup/popup'),Spinner=require('../../spinner/spinner'),SvgIcon=require('../../svg-icon/svg-icon');class ProfileModelList extends React.Component{constructor(){super(),this.state={loadingModels:!1,models:null,notification:null}}componentWillMount(){this._fetchModels(this.props.facadesExist)}componentWillReceiveProps(a){const b=this.props;(b.userInfo.profile!==a.userInfo.profile||b.facadesExist!==a.facadesExist)&&this._fetchModels(a.facadesExist)}_fetchModels(a){return a?void this.setState({loadingModels:!0},()=>{this.props.listModelsWithInfo(this._fetchModelsCallback.bind(this))}):void console.warn('Controller not connected, skipping fetching models.')}_fetchModelsCallback(a,b){this.setState({loadingModels:!1},()=>{if(a){const b='Cannot load models';return console.error(b,a),void this.props.addNotification({title:b,message:`${b}: ${a}`,level:'error'})}this.setState({models:b})})}_showConfirmation(a){const b=`Are you sure you want to destroy ${a.name}?`+' All the applications and units included in the model will be destroyed. This action cannot be undone.';this.setState({notification:React.createElement(Popup,{buttons:[{title:'Cancel',action:()=>this.setState({notification:null}),type:'inline-neutral'},{title:'Destroy',action:()=>{this.setState({notification:null}),this.props.destroyModels([a.uuid],()=>{this._fetchModels(this.props.facadesExist)})},type:'destructive'}],title:'Destroy model'},React.createElement('p',null,b))})}_destroyModel(a,b,c){return c.preventDefault(),c.stopPropagation(),a.isController?void this.props.addNotification({title:'Cannot destroy model',message:'The controller model cannot be destroyed.',level:'error'}):void this._showConfirmation(a)}_generateModels(){const a=new Map([['read','show_16'],['write','edit_16'],['admin','user_16']]),b=this.props.userInfo.profile,c=this.state.models||[];return c.reduce((c,d,e)=>{if(!d.isAlive)return c;const f=`mymodel-button-dropdown-${e}`,g=d.owner.replace('@external','')||b,h=`${this.props.baseURL}u/${g}/${d.name}`,i=d.users.find((a)=>a.displayName===b),j='admin'===i.access,k=g===b?'Me':g,l=d.region?'/'+d.region.toUpperCase():'';return c.push({columns:[{content:React.createElement('a',{href:h,onClick:this.switchToModel.bind(this,{name:d.name,id:d.id,owner:g})},d.name),columnSize:3},{content:`${d.numMachines} ${d.provider.toUpperCase()}${l}`,columnSize:3},{content:React.createElement('div',null,React.createElement(SvgIcon,{name:a.get(i.access),size:'16'}),React.createElement('span',{className:'profile-model-list__username'},k)),columnSize:3},{content:React.createElement(DateDisplay,{date:d.lastConnection||'--',relative:!0}),columnSize:2},{content:j?React.createElement('a',{onClick:this._destroyModel.bind(this,d,f)},React.createElement(SvgIcon,{name:'delete_16',size:'16'})):null,columnSize:1}],key:d.name}),c},[])||[]}switchToModel(a,b){b.preventDefault(),b.stopPropagation(),this.props.switchModel(a)}_generateNotification(){return this.state.notification?this.state.notification:void 0}render(){if(this.state.loadingModels)return React.createElement('div',{className:'profile-model-list'},React.createElement(Spinner,null));const a=this._generateModels();return React.createElement('div',{className:'profile-model-list'},React.createElement('div',{className:'profile-model-list__header twelve-col'},React.createElement(CreateModelButton,{title:'Start a new model',changeState:this.props.changeState,switchModel:this.props.switchModel}),React.createElement('span',{className:'profile-model-list__header-title'},'My models (',a.length,')')),a.length?React.createElement(BasicTable,{headers:[{content:'Name',columnSize:3},{content:'Machines, cloud/region',columnSize:3},{content:'Permissions/owner',columnSize:3},{content:'Last accessed',columnSize:2},{content:'',columnSize:1}],rows:a}):null,this._generateNotification())}}ProfileModelList.propTypes={acl:PropTypes.object,addNotification:PropTypes.func.isRequired,baseURL:PropTypes.string.isRequired,changeState:PropTypes.func.isRequired,destroyModels:PropTypes.func.isRequired,facadesExist:PropTypes.bool.isRequired,listModelsWithInfo:PropTypes.func.isRequired,models:PropTypes.array,switchModel:PropTypes.func.isRequired,userInfo:PropTypes.object.isRequired},module.exports=ProfileModelList;