'use strict';const classNames=require('classnames'),marked=require('marked'),Prism=require('prismjs'),prismLanguages=require('prism-languages'),queryString=require('query-string'),React=require('react'),ReactDOM=require('react-dom'),shapeup=require('shapeup'),yui=window.yui,autodeploy=require('./autodeploy'),initUtils=require('./utils'),hotkeys=require('./hotkeys'),jujulibConversionUtils=require('./jujulib-conversion-utils'),localCharmHelpers=require('../components/local-inspector/local-charm-import-helpers'),changesUtils=require('./changes-utils'),relationUtils=require('./relation-utils'),viewUtils=require('../views/utils'),endpointUtils=require('./endpoint-utils'),WebHandler=require('../store/env/web-handler'),Account=require('../components/account/account'),AddedServicesList=require('../components/added-services-list/added-services-list'),Charmbrowser=require('../components/charmbrowser/charmbrowser'),DeploymentBar=require('../components/deployment-bar/deployment-bar'),DeploymentFlow=require('../components/deployment-flow/deployment-flow'),EnvSizeDisplay=require('../components/env-size-display/env-size-display'),ExpandingProgress=require('../components/expanding-progress/expanding-progress'),HeaderBreadcrumb=require('../components/header-breadcrumb/header-breadcrumb'),HeaderLogo=require('../components/header-logo/header-logo'),HeaderSearch=require('../components/header-search/header-search'),Help=require('../components/help/help'),Inspector=require('../components/inspector/inspector'),ISVProfile=require('../components/isv-profile/isv-profile'),Lightbox=require('../components/lightbox/lightbox'),LocalInspector=require('../components/local-inspector/local-inspector'),Login=require('../components/login/login'),Logout=require('../components/logout/logout'),MachineView=require('../components/machine-view/machine-view'),ModelActions=require('../components/model-actions/model-actions'),ModalGUISettings=require('../components/modal-gui-settings/modal-gui-settings'),ModalShortcuts=require('../components/modal-shortcuts/modal-shortcuts'),NotificationList=require('../components/notification-list/notification-list'),Panel=require('../components/panel/panel'),PostDeployment=require('../components/post-deployment/post-deployment'),Profile=require('../components/profile/profile'),Sharing=require('../components/sharing/sharing'),Status=require('../components/status/status'),SvgIcon=require('../components/svg-icon/svg-icon'),Terminal=require('../components/terminal/terminal'),UserMenu=require('../components/user-menu/user-menu'),UserProfile=require('../components/user-profile/user-profile'),USSOLoginLink=require('../components/usso-login-link/usso-login-link'),Zoom=require('../components/zoom/zoom'),ComponentRenderersMixin=(a)=>class extends a{_renderAddedServices(a){const b=this.topology;if(b){const c=b.topo,d=c.modules.ServiceModule,e=this._domEventHandlers['topo.hoverService'];e&&document.removeEventListener('topo.hoverService',e),this._domEventHandlers['topo.hoverService']=(a)=>{this._renderAddedServices(a.detail.id)},document.addEventListener('topo.hoverService',this._domEventHandlers['topo.hoverService']),d.deselectNodes();const f=this.db;ReactDOM.render(React.createElement(Panel,{instanceName:'inspector-panel',visible:0<f.services.size()},React.createElement(AddedServicesList,{services:f.services,hoveredId:a,updateUnitFlags:f.updateUnitFlags.bind(f),findRelatedServices:f.findRelatedServices.bind(f),findUnrelatedServices:f.findUnrelatedServices.bind(f),getUnitStatusCounts:initUtils.getUnitStatusCounts,hoverService:d.hoverService.bind(d),panToService:d.panToService.bind(d),changeState:this._bound.changeState})),document.getElementById('inspector-container'))}}_renderEnvSizeDisplay(a=0,b=0){ReactDOM.render(React.createElement(EnvSizeDisplay,{appState:this.state,machineCount:b,pluralize:initUtils.pluralize.bind(this),serviceCount:a}),document.getElementById('env-size-display-container'))}_renderModelActions(){const a=this.modelAPI,b=this.applicationConfig.flags.terminal||!!localStorage.getItem('jujushell-url')||!!this.db.environment.get('jujushellURL');ReactDOM.render(React.createElement(ModelActions,{acl:this.acl,displayTerminalButton:b,appState:this.state,changeState:this._bound.changeState,exportEnvironmentFile:initUtils.exportEnvironmentFile.bind(initUtils,this.db),hideDragOverNotification:this._hideDragOverNotification.bind(this),importBundleFile:this.bundleImporter.importBundleFile.bind(this.bundleImporter),renderDragOverNotification:this._renderDragOverNotification.bind(this),sharingVisibility:this._sharingVisibility.bind(this),loadingModel:a.loading,userIsAuthenticated:a.userIsAuthenticated}),document.getElementById('model-actions-container'))}_sharingVisibility(a=!0){const b=document.getElementById('sharing-container');if(!a)return void ReactDOM.unmountComponentAtNode(b);const c=this.modelAPI,d=(a,b,d,e)=>{this.applicationConfig.gisf&&-1===b.indexOf('@')&&(b+='@external'),a(c.get('modelUUID'),[b],d,e)},e=this.controllerAPI,f=e.grantModelAccess.bind(e),g=e.revokeModelAccess.bind(e);ReactDOM.render(React.createElement(Sharing,{addNotification:this._bound.addNotification,canShareModel:this.acl.canShareModel(),closeHandler:this._sharingVisibility.bind(this,!1),getModelUserInfo:c.modelUserInfo.bind(c),grantModelAccess:d.bind(this,f),humanizeTimestamp:initUtils.humanizeTimestamp,revokeModelAccess:d.bind(this,g)}),b)}_renderTerminal(a){const b=this.applicationConfig,c=this.user,d=c.identityURL(),e=this.modelAPI,f=[],g=e.get('environmentName');if(g){const a=e.get('modelOwner');f.push(`juju switch ${a}/${g}`)}const h={};if(d&&b.gisf){const a=c.getMacaroon('identity');h.macaroons={},h.macaroons[d]=JSON.parse(atob(a))}else h.user=c.controller.user,h.password=c.controller.password;ReactDOM.render(React.createElement(Terminal,{addNotification:this._bound.addNotification,address:a,changeState:this._bound.changeState,commands:f,creds:h,WebSocket:WebSocket}),document.getElementById('terminal-container'))}_displayTerminal(a,b){const c=this.applicationConfig,d=this.db,e={title:'Juju shell unavailable',body:`GUI Version: ${window.GUI_VERSION.version}
JAAS: ${c.gisf}
Location: ${window.location.href}
Browser: ${navigator.userAgent}`},f=`${'https://github.com/juju/juju-gui/issues/new'}?${queryString.stringify(e)}`,g=initUtils.jujushellURL(localStorage,d,c);if(!g){let a='an unexpected error has occurred please file an issue ',b=React.createElement('a',{href:f,target:'_blank',key:'link'},'here');const c=d.services.getServicesFromCharmName('jujushell')[0];return!c||c.get('pending')?(a='deploy and expose the "jujushell" charm and try again.',b=null):c.get('aggregated_status').running?c&&!c.get('exposed')&&(a='expose the "jujushell" charm and try again.',b=null):(a='jujushell has not yet been successfully deployed.',b=null),this._bound.addNotification({title:'Unable to open Terminal',message:[React.createElement('span',{key:'prefix'},'Unable to open Terminal, '),React.createElement('span',{key:'message'},a),b],level:'error'}),void this.state.changeState({terminal:null})}this._renderTerminal(g),b()}_clearTerminal(a,b){ReactDOM.unmountComponentAtNode(document.getElementById('terminal-container')),b()}_renderISVProfile(){ReactDOM.render(React.createElement(ISVProfile,{d3:yui.d3}),document.getElementById('top-page-container'))}_renderUserProfile(a,b){const c=a.gui||{};if(void 0!==c.deploy||!a.profile||!this.controllerAPI.get('connected')||!this.controllerAPI.userIsAuthenticated)return;const d=!!this.controllerAPI.get('facades');if(!d){const c=this.controllerAPI.after('facadesChange',(d)=>{d.newVal&&(this._renderUserProfile(a,b),c.detach())})}const e=this.charmstore,f=this.modelUUID;let g=React.createElement(UserProfile,{acl:this.acl,addNotification:this._bound.addNotification,charmstore:e,currentModel:f,d3:yui.d3,facadesExist:d,listBudgets:this.plans.listBudgets.bind(this.plans),listModelsWithInfo:this.controllerAPI.listModelsWithInfo.bind(this.controllerAPI),getKpiMetrics:this.plans.getKpiMetrics.bind(this.plans),changeState:this._bound.changeState,destroyModels:this.controllerAPI.destroyModels.bind(this.controllerAPI),getAgreements:this.terms.getAgreements.bind(this.terms),getDiagramURL:e.getDiagramURL.bind(e),interactiveLogin:this.applicationConfig.interactiveLogin,pluralize:initUtils.pluralize.bind(this),setPageTitle:this.setPageTitle,staticURL:this.applicationConfig.staticURL,storeUser:this.storeUser.bind(this),switchModel:this._bound.switchModel,userInfo:this._getUserInfo(a)});if(this.applicationConfig.flags.profile){const b=this.payment,c=this.stripe;g=React.createElement(Profile,{acl:shapeup.fromShape(this.acl,Profile.propTypes.acl),activeSection:a.hash,addNotification:this._bound.addNotification,baseURL:this.applicationConfig.baseUrl,changeState:this._bound.changeState,charmstore:e,controllerAPI:shapeup.fromShape(this.controllerAPI,Profile.propTypes.controllerAPI),controllerIsReady:this._controllerIsReady.bind(this),controllerUser:this.user.controller.user,deployTarget:this.deployTarget.bind(this,e),destroyModels:this._bound.destroyModels,facadesExist:d,getModelName:this._getModelName.bind(this),initUtils:shapeup.fromShape(initUtils,Profile.propTypes.initUtils),listModelsWithInfo:this._bound.listModelsWithInfo,payment:b&&shapeup.fromShape(b,Account.propTypes.payment),sendAnalytics:this.sendAnalytics,showPay:this.applicationConfig.flags.pay||!1,stripe:c&&shapeup.fromShape(c,Account.propTypes.stripe),switchModel:this._bound.switchModel,userInfo:this._getUserInfo(a)})}ReactDOM.render(g,document.getElementById('top-page-container'))}_clearUserProfile(a,b){ReactDOM.unmountComponentAtNode(document.getElementById('top-page-container')),b()}_renderHeaderSearch(){ReactDOM.render(React.createElement(HeaderSearch,{appState:this.state}),document.getElementById('header-search-container'))}_renderHeaderHelp(){ReactDOM.render(React.createElement('span',{className:'header__button',onClick:(()=>{this.state.changeState({help:!0})}).bind(this),role:'button',tabIndex:'0'},React.createElement(SvgIcon,{name:'help_16',className:'header__button-icon',size:'16'}),React.createElement('span',{className:'tooltip__tooltip--below'},React.createElement('span',{className:'tooltip__inner tooltip__inner--up'},'Help'))),document.getElementById('header-help'))}_displayShortcutsModal(){ReactDOM.render(React.createElement(ModalShortcuts,{closeModal:this._clearShortcutsModal.bind(this),guiVersion:window.GUI_VERSION.version,keybindings:hotkeys.keyBindings}),document.getElementById('modal-shortcuts'))}_displaySettingsModal(){ReactDOM.render(React.createElement(ModalGUISettings,{closeModal:this._clearSettingsModal.bind(this),localStorage:localStorage}),document.getElementById('modal-gui-settings'))}_displayLightbox(a,b){ReactDOM.render(React.createElement(Lightbox,{caption:b,close:this._clearLightbox.bind(this)},a),document.getElementById('lightbox'))}_renderHelp(a,b){const c=new WebHandler;ReactDOM.render(React.createElement(Help,{changeState:this._bound.changeState,displayShortcutsModal:this._displayShortcutsModal.bind(this),gisf:this.applicationConfig.gisf,user:this.user,sendGetRequest:c.sendGetRequest.bind(c),staticURL:this.applicationConfig.staticURL||'',youtubeAPIKey:this.applicationConfig.youtubeAPIKey}),document.getElementById('help')),b()}_clearHelp(){ReactDOM.unmountComponentAtNode(document.getElementById('help'))}_displayPostDeployment(a,b){if(!a.postDeploymentPanel.show)return void b();const c=a.postDeploymentPanel.entityId;if(c){const a=new Date().getTime();this.postDeploymentPanel={openTime:a,entityId:c};const b=this.charmstore;ReactDOM.render(React.createElement(PostDeployment,{changeState:this._bound.changeState,entityId:c,getEntity:b.getEntity.bind(b),getFile:b.getFile.bind(b),makeEntityModel:jujulibConversionUtils.makeEntityModel,marked:marked,showEntityDetails:((a)=>{let b;try{b=window.jujulib.URL.fromString(a)}catch(c){b=window.jujulib.URL.fromLegacyString(a)}const c={profile:null,search:null,store:b.path()};this.state.changeState(c)}).bind(this,c)}),document.getElementById('post-deployment'))}b()}_clearShortcutsModal(){ReactDOM.unmountComponentAtNode(document.getElementById('modal-shortcuts'))}_clearSettingsModal(){ReactDOM.unmountComponentAtNode(document.getElementById('modal-gui-settings'))}_clearLightbox(){ReactDOM.unmountComponentAtNode(document.getElementById('lightbox'))}_clearPostDeployment(a,b){const c=new Date().getTime();if(this.postDeploymentPanel&&this.postDeploymentPanel.openTime&&this.postDeploymentPanel.entityId){const a=this.postDeploymentPanel.entityId,b=this.postDeploymentPanel.openTime;let d=Math.round((c-b)/1e3),e=[`${d}s`,a];this.sendAnalytics('Deployment Flow','Close post deployment panel',e.join(' - '))}ReactDOM.unmountComponentAtNode(document.getElementById('post-deployment')),b()}_renderHeaderLogo(){const a=this.user.displayName,b=this.applicationConfig.gisf,c=b?'/':this.state.generatePath({profile:a});ReactDOM.render(React.createElement(HeaderLogo,{gisf:b,homePath:c,showProfile:initUtils.showProfile.bind(this,this._bound.changeState,a)}),document.getElementById('header-logo'))}_renderCharmbrowser(a,b){const c=this.charmstore;marked.setOptions({highlight:function(a,b){const c=prismLanguages[b];if(c)return Prism.highlight(a,c)}});ReactDOM.render(React.createElement(Charmbrowser,{acl:this.acl,apiUrl:c.url,charmstoreSearch:c.search.bind(c),clearLightbox:this._clearLightbox.bind(this),deployTarget:this.deployTarget.bind(this,c),displayLightbox:this._displayLightbox.bind(this),series:viewUtils.getSeriesList(),importBundleYAML:this.bundleImporter.importBundleYAML.bind(this.bundleImporter),flags:window.juju_config.flags,getBundleYAML:c.getBundleYAML.bind(c),getEntity:(a,b)=>{let d;try{d=window.jujulib.URL.fromString(a)}catch(a){return void b(a,{})}return c.getEntity(d.legacyPath(),b)},getFile:c.getFile.bind(c),getDiagramURL:c.getDiagramURL.bind(c),getModelName:this._getModelName.bind(this),gisf:this.applicationConfig.gisf,listPlansForCharm:this.plans.listPlansForCharm.bind(this.plans),renderMarkdown:marked,deployService:this.deployService.bind(this),appState:this.state,utils:initUtils,staticURL:window.juju_config.staticURL,charmstoreURL:viewUtils.ensureTrailingSlash(window.juju_config.charmstoreURL),apiVersion:window.jujulib.charmstoreAPIVersion,addNotification:this._bound.addNotification,makeEntityModel:jujulibConversionUtils.makeEntityModel,setPageTitle:this.setPageTitle.bind(this),showTerms:this.terms.showTerms.bind(this.terms),urllib:window.jujulib.URL}),document.getElementById('charmbrowser-container')),b()}_clearCharmbrowser(a,b){a.search||a.store||(ReactDOM.unmountComponentAtNode(document.getElementById('charmbrowser-container')),b())}_renderAccount(a,b){const c=this.controllerAPI,d=this.payment,e=this.stripe;c&&c.userIsAuthenticated&&(this.modelUUID=null,ReactDOM.render(React.createElement(Account,{acl:this.acl,addNotification:this._bound.addNotification,changeState:this._bound.changeState,controllerAPI:shapeup.fromShape(c,Account.propTypes.controllerAPI),controllerIsReady:this._controllerIsReady.bind(this),initUtils:shapeup.fromShape(initUtils,Account.propTypes.initUtils),payment:d&&shapeup.fromShape(d,Account.propTypes.payment),sendAnalytics:this.sendAnalytics,showPay:this.applicationConfig.flags.pay||!1,stripe:e&&shapeup.fromShape(e,Account.propTypes.stripe),user:this.user.controller.user,userInfo:this._getUserInfo(a)}),document.getElementById('top-page-container')),b())}_clearAccount(a,b){ReactDOM.unmountComponentAtNode(document.getElementById('top-page-container')),b()}_clearAllGUIComponents(a){const b=()=>{};this._clearMachineView(a,b),this._clearDeployment(a,b),this._clearInspector(a,b)}_renderMachineView(a,b){const c=this.db,d=this.modelAPI,e=d.get('ecs'),f=MachineView.DecoratedComponent,g=f.propTypes;ReactDOM.render(React.createElement(MachineView,{acl:shapeup.fromShape(this.acl,g.acl),changeState:this._bound.changeState,dbAPI:shapeup.addReshape({addGhostAndEcsUnits:initUtils.addGhostAndEcsUnits.bind(this,c,d),applications:c.services,modelName:c.environment.get('name')||'',machines:c.machines,units:c.units}),generateMachineDetails:initUtils.generateMachineDetails.bind(initUtils,d.genericConstraints,c.units),machine:this.state.current.gui.machines,modelAPI:shapeup.addReshape({autoPlaceUnits:autodeploy.autoPlaceUnits.bind(this,c,d),createMachine:autodeploy.createMachine.bind(this,c,d),destroyMachines:d.destroyMachines.bind(d),placeUnit:d.placeUnit.bind(d),providerType:d.get('providerType')||'',removeUnits:d.remove_units.bind(d),updateMachineConstraints:e.updateMachineConstraints.bind(e),updateMachineSeries:e.updateMachineSeries.bind(e)}),parseConstraints:initUtils.parseConstraints.bind(initUtils,d.genericConstraints),parseMachineName:c.machines.parseMachineName.bind(c.machines),sendAnalytics:this.sendAnalytics,series:window.jujulib.CHARM_SERIES}),document.getElementById('machine-view')),b()}_clearMachineView(a,b){ReactDOM.unmountComponentAtNode(document.getElementById('machine-view')),b()}_renderStatusView(a,b){const c=Status.propTypes;ReactDOM.render(React.createElement(Status,{changeState:this._bound.changeState,db:shapeup.fromShape(this.db,c.db),generatePath:this.state.generatePath.bind(this.state),model:shapeup.fromShape(this.modelAPI.getAttrs(),c.model),urllib:shapeup.fromShape(window.jujulib.URL,c.urllib)}),document.getElementById('status-container')),b()}_clearStatusView(a,b){ReactDOM.unmountComponentAtNode(document.getElementById('status-container')),b()}_renderInspector(a,b){const c=this.topology;if(!c)return;const d=c.topo,e=this.charmstore;let f={};const g=a.gui.inspector,h=this.db.services.getById(g.id),i=g.localType,j=this._domEventHandlers['topo.hoverService'];j&&document.removeEventListener('topo.hoverService',j);const k=this.modelAPI,l=this.db;if(h){d.modules.ServiceModule.selectService(h.get('id'));const a=l.charms.getById(h.get('charm')),b=relationUtils.getRelatableApplications(l,endpointUtils.getEndpoints(h,this.endpointsController)),c=k.get('ecs');f=React.createElement(Inspector,{acl:this.acl,addCharm:(a,b,c)=>{k.addCharm(a,e,b,c)},addGhostAndEcsUnits:initUtils.addGhostAndEcsUnits.bind(this,l,k,h),addNotification:this._bound.addNotification,appState:this.state,charm:a,clearState:initUtils.clearState.bind(this,d),createMachinesPlaceUnits:initUtils.createMachinesPlaceUnits.bind(this,l,k,h),createRelation:relationUtils.createRelation.bind(this,l,k),destroyService:initUtils.destroyService.bind(this,l,k,h),destroyRelations:relationUtils.destroyRelations.bind(this,l,k),destroyUnits:k.remove_units.bind(k),displayPlans:-1<initUtils.compareSemver(this.applicationConfig.jujuCoreVersion,'2'),getCharm:k.get_charm.bind(k),getUnitStatusCounts:initUtils.getUnitStatusCounts,getYAMLConfig:initUtils.getYAMLConfig.bind(this),envResolved:k.resolved.bind(k),exposeService:k.expose.bind(k),getAvailableEndpoints:relationUtils.getAvailableEndpoints.bind(this,this.endpointsController,l,endpointUtils.getEndpoints),getAvailableVersions:e.getAvailableVersions.bind(e),getServiceById:l.services.getById.bind(l.services),getServiceByName:l.services.getServiceByName.bind(l.services),linkify:initUtils.linkify,modelUUID:this.modelUUID||'',providerType:k.get('providerType')||'',relatableApplications:b,service:h,serviceRelations:relationUtils.getRelationDataForService(l,h),setCharm:k.setCharm.bind(k),setConfig:k.set_config.bind(k),showActivePlan:this.plans.showActivePlan.bind(this.plans),showPlans:window.juju_config.flags.plans||!1,unexposeService:k.unexpose.bind(k),unplaceServiceUnits:c.unplaceServiceUnits.bind(c),updateServiceUnitsDisplayname:l.updateServiceUnitsDisplayname.bind(l)})}else if(i&&window.localCharmFile)this._hideDragOverNotification(),f=React.createElement(LocalInspector,{acl:this.acl,changeState:this._bound.changeState,file:window.localCharmFile,localType:i,services:l.services,series:viewUtils.getSeriesList(),upgradeServiceUsingLocalCharm:localCharmHelpers.upgradeServiceUsingLocalCharm.bind(this,k,l),uploadLocalCharm:localCharmHelpers.uploadLocalCharm.bind(this,k,l)});else return void this.state.changeState({gui:{inspector:null}});ReactDOM.render(React.createElement(Panel,{instanceName:'inspector-panel',visible:!0},f),document.getElementById('inspector-container')),b()}_clearInspector(a,b){ReactDOM.unmountComponentAtNode(document.getElementById('inspector-container')),b()}_renderDeployment(a){const b=this.modelAPI,c=this.db,d=this.modelAPI.get('connected'),e=b.get('environmentName')||'mymodel',f=b.get('ecs'),g=f.getCurrentChangeSet(),h=a.gui.deploy,i=h?JSON.parse(h):null;if(0===Object.keys(g).length&&!i)return void this.state.changeState({gui:{deploy:null}});const j=this.controllerAPI,k=c.services;autodeploy.autoPlaceUnits(c,b);let l=b.get('providerType');l&&(l={cloudType:l,name:b.get('cloud')});const m=j.loginWithMacaroon.bind(j,this.bakery),n=this.charmstore,o=autodeploy.autoPlaceUnits.bind(null,c,b);ReactDOM.render(React.createElement(DeploymentFlow,{acl:this.acl,addAgreement:this.terms.addAgreement.bind(this.terms),addNotification:this._bound.addNotification,addSSHKeys:b.addKeys.bind(b),importSSHKeys:b.importKeys.bind(b),applications:k.toArray(),charmstore:n,changesFilterByParent:changesUtils.filterByParent.bind(changesUtils,g),changeState:this._bound.changeState,cloud:l,controllerIsReady:this._controllerIsReady.bind(this),createToken:this.stripe&&this.stripe.createToken.bind(this.stripe),createCardElement:this.stripe&&this.stripe.createCardElement.bind(this.stripe),createUser:this.payment&&this.payment.createUser.bind(this.payment),credential:b.get('credential'),changes:g,charmsGetById:c.charms.getById.bind(c.charms),deploy:initUtils.deploy.bind(viewUtils,this,o,initUtils.createSocketURL),sendAnalytics:this.sendAnalytics,setModelName:b.set.bind(b,'environmentName'),formatConstraints:viewUtils.formatConstraints.bind(viewUtils),generateAllChangeDescriptions:changesUtils.generateAllChangeDescriptions.bind(changesUtils,k,c.units),generateChangeDescription:changesUtils.generateChangeDescription.bind(changesUtils,k,c.units),generateCloudCredentialName:initUtils.generateCloudCredentialName,generateMachineDetails:initUtils.generateMachineDetails.bind(initUtils,b.genericConstraints,c.units),generatePath:this.state.generatePath.bind(this.state),getAgreementsByTerms:this.terms.getAgreementsByTerms.bind(this.terms),getGithubSSHKeys:window.jujugui.sshKeys.githubSSHKeys,sortDescriptionsByApplication:changesUtils.sortDescriptionsByApplication.bind(null,k.getById.bind(k)),isLoggedIn:()=>this.controllerAPI.userIsAuthenticated,getCloudCredentials:j.getCloudCredentials.bind(j),getCloudCredentialNames:j.getCloudCredentialNames.bind(j),getCloudProviderDetails:initUtils.getCloudProviderDetails.bind(initUtils),getCurrentChangeSet:f.getCurrentChangeSet.bind(f),getCountries:this.payment&&this.payment.getCountries.bind(this.payment)||null,getDiagramURL:n.getDiagramURL.bind(n),getEntity:n.getEntity.bind(n),getUser:this.payment&&this.payment.getUser.bind(this.payment),getUserName:()=>{return this.user.username},gisf:this.gisf,groupedChanges:changesUtils.getGroupedChanges(g),gtmEnabled:this.applicationConfig.GTM_enabled,listBudgets:this.plans.listBudgets.bind(this.plans),listClouds:j.listClouds.bind(j),listPlansForCharm:this.plans.listPlansForCharm.bind(this.plans),loginToController:m,makeEntityModel:jujulibConversionUtils.makeEntityModel,modelCommitted:d,modelName:e,ddData:i,profileUsername:this._getUserInfo(a).profile,region:b.get('region'),renderMarkdown:marked,getServiceByName:k.getServiceByName.bind(k),showPay:this.applicationConfig.flags.pay||!1,showTerms:this.terms.showTerms.bind(this.terms),stats:this.stats,updateCloudCredential:j.updateCloudCredential.bind(j),username:this.user?this.user.displayName:void 0,validateForm:initUtils.validateForm.bind(initUtils),WebHandler:WebHandler,withPlans:!1}),document.getElementById('deployment-container'))}_controllerIsReady(){return!!(this.controllerAPI&&this.controllerAPI.get('connected')&&this.controllerAPI.userIsAuthenticated)}_clearDeployment(a,b){ReactDOM.unmountComponentAtNode(document.getElementById('deployment-container')),b()}_renderDeploymentBar(){var a=this.modelAPI,b=a.get('ecs'),c=this.db,d=c.services,e=d.toArray(),f=c.machines.toArray(),g=c.units;ReactDOM.render(React.createElement(DeploymentBar,{acl:this.acl,changeState:this._bound.changeState,currentChangeSet:b.getCurrentChangeSet(),generateChangeDescription:changesUtils.generateChangeDescription.bind(changesUtils,d,g),hasEntities:0<e.length||0<f.length,modelCommitted:this.modelAPI.get('connected'),sendAnalytics:this.sendAnalytics}),document.getElementById('deployment-bar-container'))}_renderLogin(a){document.getElementById('loading-message').style.display='none';ReactDOM.render(React.createElement(Login,{addNotification:this._bound.addNotification,controllerIsConnected:()=>{return this.controllerAPI&&this.controllerAPI.get('connected')},errorMessage:a,gisf:this.applicationConfig.gisf,loginToAPIs:this.loginToAPIs.bind(this),loginToController:()=>{this.loginToAPIs(null,!0,[this.controllerAPI])}}),document.getElementById('login-container'))}_clearLogin(a,b){ReactDOM.unmountComponentAtNode(document.getElementById('login-container')),b&&b()}_renderUserMenu(){const a=this.controllerAPI,b='profile-link-container',c=document.getElementById(b);if(!c)return void console.error(`no linkContainerId: ${b}`);const d=this.charmstore,e=this.bakery,f=React.createElement(USSOLoginLink,{addNotification:this._bound.addNotification,displayType:'text',loginToController:a.loginWithMacaroon.bind(a,e)});let g='/logout';const h=this.applicationConfig;h.baseUrl&&(g=h.baseUrl.replace(/\/?$/,g));const i=React.createElement(Logout,{charmstoreLogoutUrl:d.getLogoutUrl(),doCharmstoreLogout:()=>{return this.getUser('charmstore')&&!h.gisf},locationAssign:window.location.assign.bind(window.location),logoutUrl:g,visible:!this.state.current.store}),j=this.applicationConfig.flags;ReactDOM.render(React.createElement(UserMenu,{controllerAPI:a,LogoutLink:i,navigateUserAccount:()=>{const a=this.user.displayName;a&&initUtils.showAccount(this.modelAPI&&this.modelAPI.get('ecs'),this._bound.changeState)},navigateUserProfile:()=>{const a=this.user.displayName;a&&initUtils.showProfile(this._bound.changeState,a)},showAccount:!j.profile,showHelp:()=>{this.state.changeState({help:!0})},USSOLoginLink:f}),c)}_renderBreadcrumb(){const a=this.modelAPI,b=this.controllerAPI;let c=!0,d=b&&b.listModelsWithInfo.bind(this.controllerAPI);b||(c=!1),b&&null===b.findFacadeVersion('ModelManager')&&(c=!1),ReactDOM.render(React.createElement(HeaderBreadcrumb,{acl:this.acl,addNotification:this._bound.addNotification,appState:this.state,user:this.user,changeState:this._bound.changeState,humanizeTimestamp:initUtils.humanizeTimestamp,listModelsWithInfo:d,modelName:this.db.environment.get('name'),modelOwner:a.get('modelOwner'),setModelName:a.set.bind(a,'environmentName'),showEnvSwitcher:c,showProfile:initUtils.showProfile.bind(this,this._bound.changeState),switchModel:this._bound.switchModel,loadingModel:a.loading,modelCommitted:!!a.get('modelUUID')}),document.getElementById('header-breadcrumb'))}_renderProviderLogo(){const a=document.getElementById('provider-logo-container'),b=this.modelAPI.get('providerType');let c=initUtils.getCloudProviderDetails(b);const d=this.state.current||{},e=!b||!c||d.profile||'account'===d.root,f=classNames('provider-logo',{"provider-logo--disabled":e,[`provider-logo--${b}`]:b}),g=0.65;c||(c={}),ReactDOM.render(React.createElement('div',{className:f},React.createElement(SvgIcon,{height:c.svgHeight*g,name:c.id||'',width:c.svgWidth*g})),a)}_renderNotifications(a){let b=null;a&&a.details&&(b=a.details[0].model.getAttrs()),ReactDOM.render(React.createElement(NotificationList,{notification:b}),document.getElementById('notifications-container'))}_renderDragOverNotification(a=!0){this.topology.fadeHelpIndicator(a),ReactDOM.render(React.createElement(ExpandingProgress,null),document.getElementById('drag-over-notification-container'))}_hideDragOverNotification(){this.topology.fadeHelpIndicator(!1),ReactDOM.unmountComponentAtNode(document.getElementById('drag-over-notification-container'))}_renderZoom(){ReactDOM.render(React.createElement(Zoom,{topo:this.topology.topo}),document.getElementById('zoom-container'))}_renderComponents(){this._renderEnvSizeDisplay(this.db.services.size(),this.db.machines.filterByParent().length),this._renderDeploymentBar(),this._renderModelActions(),this._renderProviderLogo(),this._renderZoom(),this._renderBreadcrumb(),this._renderHeaderSearch(),this._renderHeaderHelp(),this._renderHeaderLogo();const a=this.state.current.gui;a&&(!a||a.inspector)||this._renderAddedServices()}};module.exports=ComponentRenderersMixin;